/* Notes
 * Plug in version 2
 * This generates a larger file but will allow subroutines so in the end 
 * it could be smaller
 * Limitations:
 * * Must be compiled for an exact location
 * 
 * The procedure s as follows:
 * 1) on the ByPic device use sys to get the User Start Address, for example
 *    say this is 9d027840, make this to the next 1k (0x100) boundary so
 *    it becomes 9d027900 now add 0x24 = 9d027924. This is the compile 
 *    address.
 * 2) In the linker file set the kseg0_program_mem to this address thus:
 * kseg0_program_mem     (rx)  : ORIGIN = 0x9D027924, LENGTH = 0x40000-0x2000
 * 3) Compile the program
 * 4) Edit the create.cmd program with the new address and function required
*/
#define nop()  __asm__ __volatile__ ("%(ssnop%)" : :)
// Integer pointer arithmatic, 1 is 4 bytes
#define CLR  1
#define SET  2
#define INV  3


typedef struct {
	// integers
	int *vp;	// 0    pointer
	int	v;		// 1    value
	// floats
	float fv;	// 2    value
	int a1;		// 3
	int a2;		// 4
} t_var;

int times(int a,int b)
{
	return a * b;
}

int p_test(char *c)
{
int *ip;
t_var *s = (t_var*)c;
float fl;
	s->a1 =  s->v;
	fl = 11.4;
    fl += 1;
    s->fv = fl;
    s->a2 = (int)fl;
	s->a1 = times(s->v,3);
	return 0;	
}	

void main() {}